from math import pi
# some fundamental constants, see  http://physics.nist.gov/
# (corrected 2.Oct.2006)
amu = 1.660538782e-24   # atomic mass unit [g]
c   = 2.99792458e+10    # speed of light       [cm/s]
h   = 6.62606896e-27    # Planck's constant    [erg.s]
k   = 1.3806504e-16     # Boltzmann's constant [erg/K]
C1  = 2.*pi * h * c**2  # 3.74177138E-05 erg cm**2 / s    first radiation constant
C2  = h* c / k          # 1.4387752 cm*K                 second radiation constant
